;*
;******************** *************************************
;*
;*  ATtiny13A, RC- 9,6 
;*   - 37,5 
;*
;* Main:           
;*
;* Timer2OFF:        10 
;* Timer1OFF:        15 
;* Reduct:          
;* Delay:           
;* TIMER0_COMPA:   -
;*
;* Fuses          CKSEL=10, SUT=10

;****************************************************************************

.nolist
.include "tn13def.inc"
.list

#define Li_Ion	;  
			;   
			;  3 

;*****  *****

.def	ConstH = r14  ;    Lmax
.def	ConstL = r15  ;    Lmin
.def	t1	 = r16     ;   
.def	CompM = r17    ;  
.def	Brig = r18     ;    
.def	Prot = r19     ;   
.def	Cnt0 = r20     ;   
.def	Cnt1 = r21     ; 
.def	Cnt2 = r22     ; 
.def	Cnt3 = r23     ; 
.def	Cnt4 = r24     ;              
.def	CompS = r25    ;   

;*****  *****

;    
; T.=0,0000266*(Const0*Const1*Const2),1 
; T.=0,0000266*(Const0*Const1*Const2*Const3),2 
.equ  Const0 = 250   ;  0     					  
.equ  Const1 = 250   ;  1     
.equ  Const2 = 36    ;  2     
.equ  Const3 = 10    ;  3     

.cseg

.org 0
	rjmp Initial		 ; 

.org 1					 ;  
    reti

.org 6
	rjmp TIMER0_COMPA    ;  A / T0


Initial: ;  
	
    ldi   t1,(RamEnd)
    out   spl,t1	    ;  

#ifdef Li_Ion	

.equ	StepLum = -25           ;   , U.=3,7 
.equ 	Lmin = 20               ;   
#else
.equ	StepLum = -27           ;   , U.=3,0 
.equ 	Lmin = 28               ;   
#endif
.equ  Lmax = -StepLum*7+Lmin+1  ;   
.equ  Lmax2 = -StepLum*8+Lmin

nop
	
   	ldi	t1,0b00000010  
	out	PORTB,t1        ; PB0- ,PB1- SB1
	ldi	t1,0b00000001	; PB3-  	
	out	DDRB,t1		     

ldi t1,(1<<MUX1)|(1<<MUX0)
out ADMUX,t1		;    , ADC3
ldi t1,1<<ACME
out ADCSRB,t1		;      AIN1 

ldi  t1,0            ;    T0
out  TCNT0,t1
ldi  t1,(1<<OCIE0A)
out  TIMSK0,t1       ;     T0
ldi t1,(1<<COM0A1)|(1<<WGM01)|(1<<WGM00) ;   T0,  
out TCCR0A,t1
ldi t1,(1<<CS00)     ;     CK = 9,6 MHz
out TCCR0B,t1
	 
clr CompM			 ;  
clr CompS
ldi Brig,Lmin		 ;   
out OCR0A,Brig       ;   
mov ConstL,Brig
ldi t1,Lmax2
mov ConstH,t1
ldi XL,$00           ;     
ldi XH,$A6
ldi YL,$0E

sei                  ;  

Main:  ;  

ldi t1,(1<<ACBG)
out ACSR,t1			;      AIN0 , 1,11V
ldi Cnt0,Const0     ;    , 10 
ldi Cnt1,Const1
ldi Cnt2,Const2
ldi Cnt3,Const3
ldi YH,Const0       ;    , 15 
ldi ZL,Const1
ldi ZH,Const3
Main1:
cpse Brig,ConstL    ;   Brig=Lmin,   
rjmp Main2
cpi CompS,5         ;      15 
breq Main0
Main2:
cpi CompM,5         ;      10 
breq Main0
ldi XL,$00          ;     
ldi XH,$A6
ldi YL,$0E 
clr Prot
in Prot,ACSR        ;   ,   
sbrc Prot,ACO        
breq Main3
clr t1
in t1,PINB          ;    ,  
sbrs t1,1
rcall Reduct        ;   
cpi Brig,Lmax       ;     
brsh Main3
rjmp Main1
Main3:
ldi Brig,Lmin       ;  
rjmp Main1
Main0:
clr CompM			;  
clr CompS
ldi Brig,Lmin		;   
out OCR0A,Brig       ;   
ldi t1,(1<<ACD)
out ACSR,t1			;  
ldi t1,(1<<WGM01)|(1<<WGM00);   T0, OC0A   
out TCCR0A,t1
ldi t1,(1<<INT0)
out GIMSK,t1		 ;   
ldi R23,$00          
ldi R22,$A6			 ;     
ldi R21,$0E 		 ;  0,5 , N=TF/5, T(), F()
ldi  t1,(1<<SE)|(1<<SM1);  "" , Power-Down
out  MCUCR,t1
sleep                ;   Power-Down
ldi  t1,(1<<SM1)     ;  "" , Power-Down
out  MCUCR,t1
ldi t1,0
out GIMSK,t1		 ;   
ldi  t1,0            ;    T0
out  TCNT0,t1
ldi t1,(1<<COM0A1)|(1<<WGM01)|(1<<WGM00) ;   T0,  
out TCCR0A,t1
Delay2:			     ;   
subi XL,1		 
sbci XH,0
sbci YL,0
brcc Delay2
rjmp Main

Timer2OFF: ;    10  

dec Cnt0          ;  
brne TF0          ;   ,   
ldi Cnt0,Const0
dec Cnt1          ;  
brne TF0          ;   ,   
ldi Cnt1,Const1
dec Cnt2          ;  
brne TF0          ;   ,    
ldi Cnt2,Const2
dec Cnt3          ;  
brne TF0          ;   ,    
ldi Cnt0,Const0   ;    
ldi Cnt1,Const1
ldi Cnt2,Const2
ldi Cnt3,Const3
ldi CompM,5        ;     
ret
TF0:
ret

Timer1OFF: ;    15 

dec YH            ;  
brne TF1          ;   ,   
ldi YH,Const0
dec ZL            ;  
brne TF1          ;   ,   
ldi ZL,Const1
dec ZH            ;  
brne TF1          ;   ,    
ldi YH,Const0     ;    
ldi ZL,Const1
ldi ZH,Const3
ldi CompS,5        ;     
ret 
TF1:
ret

Reduct: ;    

subi Brig,StepLum   ;      
rcall Delay
ldi YH,Const0       ;    
ldi ZL,Const1
ldi ZH,Const3
ret

Delay: ;   
subi XL,1		 
sbci XH,0
sbci YL,0
brcc Delay
ret

TIMER0_COMPA: ;    T0
  
cpse Brig,ConstH     ;    
out OCR0A,Brig       ;   
rcall Timer1OFF      ;  ,   15 
rcall Timer2OFF      ;  ,   10  
reti

;*********************************************************************************
.Exit


